Index: /WAeUP_SRP/branches/joachim-event-branch/Academics.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/Academics.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/Academics.py	(revision 1596)
@@ -51,5 +51,5 @@
     def importLocalRoles(self,portal_type): ###(
         name = '%sLocalRoles' % portal_type
-        logger = logging.getLogger('Import.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.importLocalRoles')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start importing %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -74,5 +74,5 @@
                         member_id = r.split(':')[1]
                         odict[obj_id].manage_setLocalRoles(member_id, roles_dict[r])
-                        logger.info('importing role for %s %s %s' % (obj_id, member_id,roles_dict[r]))
+                        logger.info('Importing role for %s %s %s' % (obj_id, member_id,roles_dict[r]))
 
 ###)
@@ -87,5 +87,5 @@
         name = 'Faculties'
         no_import = False
-        logger = logging.getLogger('Import.%s_csv' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.loadFacultiesFromCSV')
         logger.info('Start loading from %s.csv' % name)
         academics = self.portal_catalog({'meta_type': 'AcademicsFolder'})[-1].getObject()
@@ -134,5 +134,5 @@
         name = 'Departments'
         no_import = False
-        logger = logging.getLogger('Import.Departments')
+        logger = logging.getLogger('Academics.AcademicsFolder.loadDepartmentsFromCSV')
         fields = ("code",
                   "review_state",
@@ -191,5 +191,5 @@
         name = 'Courses'
         no_import = False
-        logger = logging.getLogger('Import.Courses')
+        logger = logging.getLogger('Academics.AcademicsFolder.loadCoursesFromCSV')
         fields = ("code",
                   "review_state",
@@ -296,5 +296,5 @@
         wf = self.portal_workflow
         no_import_list = []
-        logger = logging.getLogger('Import.Certificates')
+        logger = logging.getLogger('Academics.AcademicsFolder.loadCertificatesFromCSV')
         fields = ("code",
                   "review_state",
@@ -374,9 +374,8 @@
         """install Certificate Courses from CSV values"""
         #return
-        logger = logging.getLogger('Import.CertificateCourses')
+        logger = logging.getLogger('Academics.AcademicsFolder.loadCertificateCoursesFromCSV')
         name = 'CertificateCourses'
         wf = self.portal_workflow
         no_import_list = []
-        logger = logging.getLogger('Import.CertificateCourses')
         fields = ("code",
                   "review_state",
@@ -446,5 +445,5 @@
                 continue
             l.invokeFactory('CertificateCourse',course_code)
-            logger.info('Creating CertificateCourse %(code)s in certificate %(certificate_code)s Level %(level)s' % cert_course)
+            logger.info('Creating CertificateCourse %(code)s in Certificate %(certificate_code)s StudyLevel %(level)s' % cert_course)
             cc = getattr(l,course_code)
             semester = 'first'
@@ -492,5 +491,5 @@
     def exportLocalRoles(self,portal_type): ###(
         name = '%sLocalRoles' % portal_type
-        logger = logging.getLogger('Export.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.exportLocalRoles')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start exporting %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -505,5 +504,5 @@
             for (groupname, roles) in obj.get_local_group_roles():
                 lr[ 'group:' + group ] = [x for x in roles]
-            logger.info('exporting %s %s ' % (obj.id, lr))
+            logger.info('Exporting %s %s ' % (obj.id, lr))
             export.append('"%s","%s"' % (obj.getId(),lr))
         open("%s/import/%s-%s.csv" % (i_home,name,current),"w+").write('\n'.join(export))
@@ -519,5 +518,5 @@
         name = 'Faculties'
         no_import = False
-        logger = logging.getLogger('Export.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.exportFacultiesToCSV')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start exporting %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -526,5 +525,5 @@
         export.append('"code","review_state","title","title_prefix","college_code","degree_grade","bank_code"')
         for obj in objects:
-            logger.info('exporting %s %s ' % (obj.id, obj.title))
+            logger.info('Exporting %s %s ' % (obj.id, obj.title))
             obj_d = obj.getContent()
             di = {}
@@ -552,5 +551,5 @@
         name = 'Departments'
         no_import = False
-        logger = logging.getLogger('Export.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.exportDepartmentsToCSV')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start exporting %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -570,5 +569,5 @@
                     di['review_state'] = self.portal_workflow.getInfoFor(department,'review_state','no_state')
                     export.append('"%(code)s","%(review_state)s","%(title)s","%(title_prefix)s","%(faculty_code)s"' % di)
-                    logger.info('exporting %s %s ' % (department.id, department.title))
+                    logger.info('Exporting %s %s ' % (department.id, department.title))
                 except:
                     logger.info('could not export %s %s ' % (department.id, department.title))
@@ -584,5 +583,5 @@
         name = 'Courses'
         no_import = False
-        logger = logging.getLogger('Export.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.exportCoursesToCSV')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start exporting %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -614,5 +613,5 @@
                     di['review_state'] = self.portal_workflow.getInfoFor(course,'review_state','no_state')
                     export.append(dataline % di)
-                    logger.info('exporting %s %s ' % (course.id, course.title))
+                    logger.info('Exporting %s %s ' % (course.id, course.title))
                     continue
         open("%s/import/%s-%s.csv" % (i_home,name,current),"w+").write('\n'.join(export))
@@ -626,5 +625,5 @@
         name = 'Certificates'
         no_import = False
-        logger = logging.getLogger('Export.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.exportCertificatesToCSV')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start exporting %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -668,5 +667,5 @@
                     try:
                         export.append(dataline % di)
-                        logger.info('exporting %s %s ' % (certificate.id, certificate.title))
+                        logger.info('Exporting %s %s ' % (certificate.id, certificate.title))
                     except:
                         logger.info('could not export %s %s ' % (certificate.id, certificate.title))
@@ -682,5 +681,5 @@
         name = 'CertificateCourses'
         no_import = False
-        logger = logging.getLogger('Export.%s' % name)
+        logger = logging.getLogger('Academics.AcademicsFolder.exportCertificateCoursesToCSV')
         current = DateTime.DateTime().strftime("%d-%m-%y_%H_%M_%S")
         logger.info('Start exporting %(name)s to %(name)s_%(current)s.csv' % vars())
@@ -714,7 +713,7 @@
                                     try:
                                         export.append(dataline % di)
-                                        logger.info('exporting %s %s ' % (certificate.id, certificate.title))
+                                        logger.info('Exporting %s %s ' % (certificate.id, certificate.title))
                                     except:
-                                        logger.info('could not export %s %s ' % (certificate.id, certificate.title))
+                                        logger.info('Could not export %s %s ' % (certificate.id, certificate.title))
                                         continue
         open("%s/import/%s-%s.csv" % (i_home,name,current),"w+").write('\n'.join(export))
Index: /WAeUP_SRP/branches/joachim-event-branch/Accommodation.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/Accommodation.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/Accommodation.py	(revision 1596)
@@ -107,5 +107,5 @@
         no_import = []
         imported = []
-        logger = logging.getLogger('Import.%s' % name)
+        logger = logging.getLogger('Accommodation.AccoFolder.importReservedBeds')
         try:
             beds = csv.DictReader(open("%s/import/%s.csv" % (i_home,name),"rb"))
@@ -169,5 +169,5 @@
                     no_import.append( format_error % bed)
                     continue
-                halls[hall] = hall_doc = hall_object.getContent() 
+                halls[hall] = hall_doc = hall_object.getContent()
             bid = "%(hall)s_%(block)s_%(room)s_%(bed)s" % bed
             res = accommodation(bed = bid)
@@ -201,5 +201,5 @@
                     acco_doc.edit(mapping={'bed': bid})
                     member = self.portal_membership.getAuthenticatedMember()
-                    logger.info('"%s","changed reserved bed %s for","%s"' % (member,bid,sid))
+                    logger.info('%s changed reserved bed %s for %s' % (member,bid,sid))
             accommodation.modifyRecord(bed = bid, student = sid)
             imported.append( format % bed)
@@ -227,5 +227,5 @@
         return self.REQUEST.RESPONSE.redirect("%s" % self.REQUEST.get('URL1'))
 
-        
+
 InitializeClass(AccoFolder)
 
@@ -256,5 +256,5 @@
 InitializeClass(AccoHall)
 
-    
+
 def addAccoHall(container, id, REQUEST=None, **kw):
     """Add a AccoHall."""
Index: /WAeUP_SRP/branches/joachim-event-branch/PatchCPSUserFolderUserFolder.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/PatchCPSUserFolderUserFolder.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/PatchCPSUserFolderUserFolder.py	(revision 1596)
@@ -71,12 +71,22 @@
     ## patch to assign dynamic roles for WAeUP
     while 1:
+        if self.isStudent():
+            break
+        groups = self.portal_membership.getAuthenticatedMember().getGroups()
+        if not ("ClearanceOfficers" in groups or "CourseAdvisers" in groups):
+            break
         if callable(real_object) and hasattr(real_object,'im_self'):
             real_object = real_object.im_self
 
+        if real_object is None:
+            break
         if hasattr(real_object,'portal_type') and\
-                   real_object.portal_type not in ("Student","StudentClearance","StudentStudyLevel"):
+                   real_object.portal_type not in ("Student",
+                                                   "StudentClearance",
+                                                   "StudentStudyLevel"):
             break
-
-        #from pdb import set_trace;set_trace()
+        # don't test if it is not a proxy 
+        if real_object.portal_type == real_object.meta_type:
+            break
         # can be later simplified by replacing by students_catalog values - Henrik
         # getattr works always because of acquisition ?! Henrik
@@ -84,4 +94,5 @@
         if sc is None:
             break
+        #from pdb import set_trace;set_trace()
         sc_obj = sc.getContent()
         cert_id = sc_obj.study_course
@@ -110,16 +121,28 @@
                                                 )
         if real_object.portal_type == "StudentStudyLevel":
-            context_obj = getattr(certificate_obj,real_object.getId())
-            allowed = ('CourseAdviser', 'SectionManager')
+            context_obj = getattr(certificate_obj,real_object.getId(),None)
+            if context_obj is None:
+                break
+            allowed = set(('CourseAdviser', 'SectionManager'))
+        elif real_object.portal_type == "Student" and "CourseAdvisers" in groups:
+            #we need some special processing since CourseAdvisers are only 
+            #specified per StudyLevel
+            allowed = set(('CourseAdviser', 'SectionManager'))
+            for context_obj in certificate_obj.objectValues():
+                dynamic_roles = set(self.getRolesInContext(context_obj))
+                intersect = dynamic_roles & allowed
+                if intersect:
+                    roles.extend(list(intersect))
+            break
         else:
             res = self.portal_catalog(portal_type="Department",id=dep_id)
-            allowed = ('ClearanceOfficer', 'SectionManager')
+            allowed = set(('ClearanceOfficer', 'SectionManager'))
             if len(res) != 1:
                 break
             context_obj = res[0].getObject()
-        dynamic_roles = self.getRolesInContext(context_obj)
-        for dr in allowed:
-            if dr in dynamic_roles:
-                roles.append(dr)
+        dynamic_roles = set(self.getRolesInContext(context_obj))
+        intersect = dynamic_roles & allowed
+        if intersect:
+            roles.extend(list(intersect))
         break
     return roles
Index: /WAeUP_SRP/branches/joachim-event-branch/ScratchCards.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/ScratchCards.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/ScratchCards.py	(revision 1596)
@@ -37,5 +37,5 @@
         """import PinBatch"""
         name = "PINS"
-        logger = logging.getLogger('Import.%s' % name)
+        logger = logging.getLogger('Students.ScratchCardBatchesFolder.importPinBatch')
         logger.info('Start loading from %s.csv' % name)
         pins_section = self.portal_url.getPortalObject().campus.pins
@@ -66,5 +66,5 @@
             dict['no_of_pins'] = n - 1
             batch.getContent().edit(mapping=dict)
-            logger.info('Added %s with %d Pins' % (bid,n-1))
+            logger.info('%s with %d PINs added' % (bid,n-1))
         return self.REQUEST.RESPONSE.redirect("%s" % self.REQUEST.get('URL1'))
     ###)
@@ -140,5 +140,5 @@
             return unused[-max_pins:]
         return unused
-    
+
     security.declareProtected(View,"getUsedPins")
     def getUsedPins(self):
